/*
   This file is part of TALER
   Copyright (C) 2024 Taler Systems SA

   TALER is free software; you can redistribute it and/or modify it under the
   terms of the GNU General Public License as published by the Free Software
   Foundation; either version 3, or (at your option) any later version.

   TALER is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
   A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   TALER; see the file COPYING.  If not, see <http://www.gnu.org/licenses/>
 */
/**
 * @file src/donaudb/create_tables.c
 * @brief Implementation of the create_tables function for Postgres
 * @author Johannes Casaburi
 */
#include <donau_config.h>
#include <taler/taler_error_codes.h>
#include <taler/taler_dbevents.h>
#include <taler/taler_pq_lib.h>
#include "create_tables.h"
#include "helper.h"


enum GNUNET_GenericReturnValue
DONAUDB_create_tables (struct DONAUDB_PostgresContext *ctx)
{
  struct GNUNET_PQ_QueryParam params[] = {
    GNUNET_PQ_query_param_end
  };

  if (GNUNET_SYSERR ==
      GNUNET_PQ_load_versioning (ctx->conn))
  {
    GNUNET_break (0);
    return GNUNET_SYSERR;
  }
  if (GNUNET_OK !=
      GNUNET_PQ_run_sql (ctx->conn,
                         "donau-"))
  {
    GNUNET_break (0);
    return GNUNET_SYSERR;
  }
  if (GNUNET_OK !=
      GNUNET_PQ_exec_sql (ctx->conn,
                          "procedures"))
  {
    GNUNET_log (GNUNET_ERROR_TYPE_ERROR,
                "Failed to load stored procedures\n");
    return GNUNET_SYSERR;
  }
  if (GNUNET_OK !=
      GNUNET_PQ_prepare_anon (ctx->conn,
                              "CALL donau.do_create_tables();"))
  {
    GNUNET_break (0);
    return GNUNET_SYSERR;
  }
  if (0 >
      GNUNET_PQ_eval_prepared_non_select (ctx->conn,
                                          "",
                                          params))
  {
    GNUNET_log (GNUNET_ERROR_TYPE_ERROR,
                "Failed to create tables\n");
    return GNUNET_SYSERR;
  }
  return GNUNET_OK;
}
